Botan 2.19.5 Crypto and TLS for C&

Public Types | Public Member Functions | Protected Member Functions | List of all members
Botan::Hex_Encoder Class Referencefinal

`#include <filters.h>`

Inheritance diagram for Botan::Hex_Encoder:

## Public Types
enum | Case { Uppercase , Lowercase }

## Public Member Functions
virtual bool | attachable ()
void | end_msg () override
| Hex_Encoder (bool newlines=false, size_t line_length=72, Case the_case=Uppercase)
| Hex_Encoder (Case the_case)
std::string | name () const override
virtual void | start_msg ()
void | write (const uint8_t in[], size_t length) override

## Protected Member Functions
template<typename Alloc >
void | send (const std::vector< uint8_t, Alloc > &in)
template<typename Alloc >
void | send (const std::vector< uint8_t, Alloc > &in, size_t length)
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)

## Detailed Description

Converts arbitrary binary data to hex strings, optionally with newlines inserted

Definition at line 577 of file filters.h.

## Member Enumeration Documentation

## ◆ Case

enum Botan::Hex_Encoder::Case

Whether to use uppercase or lowercase letters for the encoded string.

Enumerator
Uppercase |
Lowercase |

Definition at line 583 of file filters.h.

583{ Uppercase, Lowercase };
Botan::Hex_Encoder::Lowercase
@ Lowercase
Definition: filters.h:583
Botan::Hex_Encoder::Uppercase
@ Uppercase
Definition: filters.h:583

## Constructor & Destructor Documentation

## ◆ Hex_Encoder() [1/2]

Botan::Hex_Encoder::Hex_Encoder | ( | Case | the_case | ) |
| explicit

Create a hex encoder.

Parameters

  the_case | the case to use in the encoded strings.

Definition at line 34 of file hex_filt.cpp.

34 : m_casing(c), m_line_length(0)
35 {
36 m_in.resize(HEX_CODEC_BUFFER_SIZE);
37 m_out.resize(2*m_in.size());
38 m_counter = m_position = 0;
39 }
Botan::HEX_CODEC_BUFFER_SIZE
const size_t HEX_CODEC_BUFFER_SIZE
Definition: hex_filt.cpp:18

References Botan::HEX_CODEC_BUFFER_SIZE.

## ◆ Hex_Encoder() [2/2]

Botan::Hex_Encoder::Hex_Encoder | ( | bool | newlines = `false`,
|  | size_t | line_length = `72`,
|  | Case | the_case = `Uppercase`
| ) |  |

Create a hex encoder.

Parameters

  newlines | should newlines be used
  line_length | if newlines are used, how long are lines
  the_case | the case to use in the encoded strings

Definition at line 23 of file hex_filt.cpp.

23 :
24 m_casing(c), m_line_length(breaks ? length : 0)
25 {
26 m_in.resize(HEX_CODEC_BUFFER_SIZE);
27 m_out.resize(2*m_in.size());
28 m_counter = m_position = 0;
29 }

References Botan::HEX_CODEC_BUFFER_SIZE.

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::DataSink, and Botan::SecureQueue.

Definition at line 52 of file filter.h.

52{ return true; }

## ◆ end_msg()

void Botan::Hex_Encoder::end_msg | ( |  | ) |
| override virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 97 of file hex_filt.cpp.

98 {
99 encode_and_send(m_in.data(), m_position);
100 if(m_counter && m_line_length)
101 send('\n');
102 m_counter = m_position = 0;
103 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

References Botan::Filter::send().

## ◆ name()

std::string Botan::Hex_Encoder::name | ( |  | ) | const
| inline override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 585 of file filters.h.

585{ return "Hex_Encoder"; }

## ◆ send() [1/4]

template<typename Alloc >

void Botan::Filter::send | ( | const std::vector< uint8_t, Alloc > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 71 of file filter.h.

72 {
73 send(in.data(), in.size());
74 }

## ◆ send() [2/4]

template<typename Alloc >

void Botan::Filter::send | ( | const std::vector< uint8_t, Alloc > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 BOTAN_ASSERT_NOMSG(length <= in.size());
84 send(in.data(), length);
85 }
BOTAN_ASSERT_NOMSG
#define BOTAN_ASSERT_NOMSG(expr)
Definition: assert.h:68

References BOTAN_ASSERT_NOMSG.

## ◆ send() [3/4]

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

References Botan::Filter::write().

Referenced by Botan::Base64_Encoder::end_msg(), Botan::Base64_Decoder::end_msg(), end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::write(), and Botan::Hex_Decoder::write().

## ◆ send() [4/4]

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

65{ send(&in, 1); }

References Botan::Filter::send().

Referenced by Botan::Filter::send().

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40{ /* default empty */ }

## ◆ write()

void Botan::Hex_Encoder::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| override virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 74 of file hex_filt.cpp.

75 {
76 buffer_insert(m_in, m_position, input, length);
77 if(m_position + length >= m_in.size())
78 {
79 encode_and_send(m_in.data(), m_in.size());
80 input += (m_in.size() - m_position);
81 length -= (m_in.size() - m_position);
82 while(length >= m_in.size())
83 {
84 encode_and_send(input, m_in.size());
85 input += m_in.size();
86 length -= m_in.size();
87 }
88 copy_mem(m_in.data(), input, length);
89 m_position = 0;
90 }
91 m_position += length;
92 }
Botan::buffer_insert
size_t buffer_insert(std::vector< T, Alloc > &buf, size_t buf_offset, const T input[], size_t input_length)
Definition: mem_ops.h:228
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:133

References Botan::buffer_insert(), and Botan::copy_mem().

The documentation for this class was generated from the following files:

- src/lib/filters/filters.h
- src/lib/filters/hex_filt.cpp